// i8012W_Basic_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\lib\pac_i8012W.h"
#pragma comment(lib,"..\\lib\\pac_i8012w.lib")



int _tmain(int argc, _TCHAR* argv[])
{
	char modulecnt=0,gain_arr[2][30]={"+/- 5V","+/- 10V"};
	int i,j,slot[8]={-1,-1,-1,-1,-1,-1,-1,-1},ret,libver,ch,gain;
	char libdate[30],act;
	unsigned short gainValue;
	short offsetValue;
	short hval;
	float fval;
	unsigned long t1,t2;


	for(i=0;i<8;i++)
	{
		ret=pac_i8012W_Init(i);
		if(ret==0)
		{
			slot[i]=i;
			printf(" Find I-9012 on slot %d Firmware Version %d!!\n",slot[i],pac_i8012W_GetFirmwareVersion(slot[i]));
			modulecnt|=(1<<i);
		}
	}
	if(modulecnt==0)
	{
		printf(" No I-9012 on Backplane\n");
		getchar();
		return 0;
	}
	
	libver=pac_i8012W_GetLibVersion();
	pac_i8012W_GetLibDate(libdate);
	printf(" library Version %X\n library Build data %s\n",libver,libdate);

	printf(" Select AI range : \n");
	printf(" 0 : +/- 5V\n");
	printf(" 1 : +/-10V\n");
	gain=getchar()-'0';

	for(i=0;i<8;i++)
	{
		if(slot[i]!=-1)
		{
			printf("Slot : %d \n",slot[i]);
			for(ch=0;ch<8;ch++)
			{
				pac_i8012W_ReadGainOffset(slot[i],ch,gain,&gainValue,&offsetValue);
				printf(" CH_%d range_%s gain value_%X offset value_%d \n",ch,gain_arr[gain],gainValue,offsetValue);
			}
		}
	}
	
	for(i=0;i<8;i++)
	{
		if(slot[i]!=-1)
		{
			printf("Slot : %d \n",slot[i]);
			for(ch=0;ch<8;ch++)
			{
				pac_i8012W_Read_AI(slot[i],ch,gain,&fval);
				pac_i8012W_Read_AIHex(slot[i],ch,gain,&hval);
				printf("ch_%d %f %X \n",ch,fval,hval);
			}
		}
	}
	

	getchar();
	getchar();

	return 0;
}